/*
 * Kerneos
 * Copyright (C) 2012 Bull S.A.S.
 * Contact: jasmine AT ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * $Id$
 */

package org.ow2.kerneos.core;

import org.apache.felix.ipojo.annotations.Component;
import org.apache.felix.ipojo.annotations.Property;
import org.apache.felix.ipojo.annotations.Provides;
import org.apache.felix.ipojo.annotations.ServiceProperty;
import org.osgi.framework.Bundle;
import org.osgi.framework.BundleContext;
import org.ow2.kerneos.common.config.generated.ModuleFragment;
import org.ow2.kerneos.common.service.KerneosModuleFragment;

@Component
@Provides
public class ModuleFragmentImpl implements KerneosModuleFragment {
    public static final String ID = "ID";
    public static final String MODULE_ID = "MODULE-ID";
    public static final String BUNDLE = "BUNDLE";
    public static final String CONFIGURATION = "CONFIGURATION";

    @Property(name = ID)
    @ServiceProperty(name = KerneosModuleFragment.ID)
    private String id;

    @Property(name = MODULE_ID)
    private String moduleId;

    @Property(name = CONFIGURATION)
    private ModuleFragment configuration;

    @Property(name = BUNDLE)
    private long bundle;

    private BundleContext bundleContext;

    private ModuleFragmentImpl(BundleContext bundleContext) {
        this.bundleContext = bundleContext;
    }

    @Override
    public ModuleFragment getConfiguration() {
        return configuration;
    }

    @Override
    public String getId() {
        return id;
    }

    @Override
    public String getModuleId() {
        return moduleId;
    }

    @Override
    public Bundle getBundle() {
        return bundleContext.getBundle(bundle);
    }
}
